<template>
  <main>
    <div class="movies">
      <div class="discover mx-auto xl:max-w-screen-xl lg:max-w-screen-lg lg:px-10 sm:max-w-screen-lg mb-12 pt-14 sm:px-7">
        <div class="title-with-filter flex justify-between aligns-center mb-11 px-4 sm:px-0">
          <h3 class="font-bold text-3xl text-gray-300 pt-3 lg:text-2xl">Movies</h3>
        </div>
        <div class="flex flex-wrap sm:-mx-2 sm:flex-nowrap px-4 sm:px-0">
          <div class="flex w-full sm:mx-2 sm:w-1/4 py-3 h-full">
            <div class="filter bg-gradient-to-b from-gray-900 via-gray-800 to-transparent rounded-lg w-full mb-4">
              <div class="filter-item text-white pt-5 px-5 pb-5 lg:text-sm">
                Sort Result By
              </div>
              <div class="filter-item text-white pt-5 px-5 pb-7">
                <select ref="select2" class="select2 appearance-none block w-full bg-white bg-opacity-5 text-white py-3 px-4 pr-8 rounded-md leading-tight lg:text-sm">
                  <option value="option1">Option 1</option>
                  <option value="option2">Option 2</option>
                  <option value="option3">Option 3</option>
                </select>
              </div>
              <div class="filter-item text-white py-3 px-5 lg:text-sm">
                Genres
              </div>
              <div class="filter-item py-3 px-5">
                <div class="checkbox flex justify-between mb-3">
                  <label class="text-white text-sm ">Action</label>
                  <input type="checkbox" class="form-checkbox h-4 w-4 text-blue-600">
                </div>
                <div class="checkbox flex justify-between mb-3">
                  <label class="text-white text-sm ">Adventure</label>
                  <input type="checkbox" class="form-checkbox h-4 w-4 text-blue-600">
                </div>
                <div class="checkbox flex justify-between mb-3">
                  <label class="text-white text-sm ">Animation</label>
                  <input type="checkbox" class="form-checkbox h-4 w-4 text-blue-600">
                </div>
                <div class="checkbox flex justify-between mb-3">
                  <label class="text-white text-sm ">Comedy</label>
                  <input type="checkbox" class="form-checkbox h-4 w-4 text-blue-600">
                </div>
                <div class="checkbox flex justify-between mb-3">
                  <label class="text-white text-sm ">Crime</label>
                  <input type="checkbox" class="form-checkbox h-4 w-4 text-blue-600">
                </div>
                <div class="checkbox flex justify-between mb-3">
                  <label class="text-white text-sm ">Documentary</label>
                  <input type="checkbox" class="form-checkbox h-4 w-4 text-blue-600">
                </div>
                <div class="checkbox flex justify-between mb-3">
                  <label class="text-white text-sm ">Drama</label>
                  <input type="checkbox" class="form-checkbox h-4 w-4 text-blue-600">
                </div>
                <div class="checkbox flex justify-between mb-3">
                  <label class="text-white text-sm ">Family</label>
                  <input type="checkbox" class="form-checkbox h-4 w-4 text-blue-600">
                </div>
                <div class="checkbox flex justify-between mb-3">
                  <label class="text-white text-sm ">Fantasy</label>
                  <input type="checkbox" class="form-checkbox h-4 w-4 text-blue-600">
                </div>
                <div class="checkbox flex justify-between mb-3">
                  <label class="text-white text-sm ">History</label>
                  <input type="checkbox" class="form-checkbox h-4 w-4 text-blue-600">
                </div>
                <div class="checkbox flex justify-between mb-3">
                  <label class="text-white text-sm ">Horror</label>
                  <input type="checkbox" class="form-checkbox h-4 w-4 text-blue-600">
                </div>
              </div>
            </div>
          </div>
          <div class="flex flex-wrap w-full sm:mx-2 sm:w-3/4">
            <div v-for="(movie, index) in movies" :key="index" class="w-full sm:w-1/3 lg:w-1/5 px-3 py-3 relative">
              <figure class="relative mb-3">
                <img :src="movie.image" :alt="movie.title" class="w-full">
                <div class="rate absolute top-0 right-0 z-20 bg-opacity-80 bg-gray-800 text-white font-semibold text-lg p-2 lg:text-sm">{{ movie.rating }}</div>
                <div class="hover:bg-gray-900 hover:opacity-100 transition duration-300 ease-in-out absolute inset-0 z-30 flex flex-col justify-center items-center p-4 opacity-0">
                  <div class="flex items-center flex-col justify-center align-center gap-14 lg:gap-5 sm:gap-6">
                    <div class="text-white font-semibold text-2xl leading-7 flex aligns-center lg:text-xs sm:text-xs"><img class="mr-1 sm:w-4" src="/images/material/ico-star-2x.svg" alt="">{{ movie.rating }}</div>
                    <div class="text-white font-bold text-xl text-center lg:text-xs sm:text-xs">{{ movie.genre }}</div>
                    <router-link :to="{ name: 'movies-detail', params: { id: movie.id } }" class="bg-gray-800 hover:bg-gray-700 text-white inline-block bg-red-500 rounded-full font-bold text-white uppercase text-sm px-8 py-2 sm:text-xs lg:px-5 lg:py-1">
                      View
                    </router-link>
                  </div>
                </div>
              </figure>
              <figcaption>
                <p class="font-medium text-gray-300 text-base leading-5 mb-1 w-full truncate lg:text-sm">{{ movie.title }}</p>
                <span class="text-sm leading-4 text-gray-500 lg:px-xs">{{ movie.year }}</span>
              </figcaption>
            </div>
          </div>
        </div>
      </div>
    </div>
  </main>
</template>
<style scope lang="css">
  .movies {
    position: relative;
  }
  .movies::before {
    background: rgba(255, 255, 255, 0.05);
    content: '';
    left: 0;
    height: 323px;
    position: absolute;
    right: 0;
    top: 0;
    z-index: -1;
  }
  .discover h3 {
    position: relative;
  }
  .discover h3::before {
    background-color: #e74c3c;
    content: "";
    height: 6px;
    left: 0;
    position: absolute;
    top: 0;
    width: 112px;
  }
  .filter .filter-item {
    border-bottom: 1px solid rgba(255, 255, 255, 0.07);
  }
  .filter .filter-item:last-child {
    border-bottom: 0;
  }
  .filter .filter-item .checkbox input[type="checkbox"] {
    background: #1E232A;
    border: 1px solid rgba(255, 255, 255, 0.5);
    border-radius: 4px;
  }
  .filter .filter-item .select2 {
    background-image:
      linear-gradient(45deg, transparent 50%, white 50%),
      linear-gradient(135deg, white 50%, transparent 50%),
      linear-gradient(to right, #ccc, #ccc);
    background-position:
      calc(100% - 20px) calc(1em + 2px),
      calc(100% - 15px) calc(1em + 2px),
      calc(100% - 2.5em) 0.5em;
    background-size:
      5px 5px,
      5px 5px,
      1px 0;
    background-repeat: no-repeat;
  }
  .filter .filter-item .select2:focus {
    background-image:
      linear-gradient(45deg, grey 50%, transparent 50%),
      linear-gradient(135deg, transparent 50%, grey 50%),
      linear-gradient(to right, #ccc, #ccc);
    background-position:
      calc(100% - 15px) 1.2em,
      calc(100% - 20px) 1.2em,
      0 0;
    background-size:
      5px 5px,
      5px 5px,
      1px 0;
    background-repeat: no-repeat;
    border-color: green;
    outline: 0;
  }
  .filter .filter-item .select2 option {
    background: black;
    color: white;
    font-weight: 400;
    font-size: 13px;
    line-height: 16px;
    margin: 4px 0;
  }
</style>
<script>
  import 'select2/dist/css/select2.min.css';
  import $ from 'jquery';
  import 'select2';

  export default {
    data() {
      return {
        movies: [
          { 
            id: 1,
            title: "Wonder Woman 1984",
            image: "/images/content/image-4.jpg",
            genre: "Fantasy, Action, Adventure",
            rating: "7.0",
            year: 2020 
          },
          { 
            id: 2,
            title: "Below Zero",
            image: "/images/content/image-5.jpg",
            rating: "6.4",
            genre: "Fantasy, Action, Adventure",
            year: 2021 
          },
          { 
            id: 3,
            title: "The Little Things",
            image: "/images/content/image-6.jpg",
            rating: "6.3",
            genre: "Fantasy, Action, Adventure",
            year: 2021 
          },
          { 
            id: 4,
            title: "Outside the Wire",
            image: "/images/content/image-7.jpg",
            rating: "6.5",
            genre: "Fantasy, Action, Adventure",
            year: 2021 
          },
          { 
            id: 5,
            title: "Black Water: Abyss",
            image: "/images/content/image-8.jpg",
            rating: "5.1",
            genre: "Fantasy, Action, Adventure",
            year: 2020 
          },
          { 
            id: 6,
            title: "Breach",
            image: "/images/content/image-9.jpg",
            rating: "4.6",
            genre: "Fantasy, Action, Adventure",
            year: 2021 
          },
          { 
            id: 7,
            title: "Soul",
            image: "/images/content/image-10.jpg",
            rating: "8.3",
            genre: "Fantasy, Action, Adventure",
            year: 2020 
          },
          { 
            id: 8,
            title: "Fast & Furious Present 8",
            image: "/images/content/image-11.jpg",
            rating: "6.9",
            genre: "Fantasy, Action, Adventure",
            year: 2017 
          },
          { 
            id: 9,
            title: "The Croods: A New Age",
            image: "/images/content/image-12.jpg",
            rating: "7.6",
            genre: "Fantasy, Action, Adventure",
            year: 2020
          },
          { 
            id: 10,
            title: "Vanguard",
            image: "/images/content/image-13.jpg",
            rating: "6.3",
            genre: "Fantasy, Action, Adventure",
            year: 2020
          },
          { 
            id: 11,
            title: "The New Mutants",
            image: "/images/content/image-14.jpg",
            genre: "Fantasy, Action, Adventure",
            rating: "7.0",
            year: 2020 
          },
          { 
            id: 12,
            title: "Tenet",
            image: "/images/content/image-15.jpg",
            rating: "7.0",
            genre: "Fantasy, Action, Adventure",
            year: 2021 
          },
        ]
      }
    },
    mounted() {
      if (typeof $.fn.select2 === 'undefined') {
        console.log('Select2 not loaded');
      } else {
        console.log('Select2 loaded');
        $(this.$refs.select2).select2();
        $(this.$refs.select2).on('change', this.handleInput);
      }
    }
  };
</script>